#include <windows.h>
#include "tp_stub.h"

//---------------------------------------------------------------------------

// ATL
#if _MSC_VER == 1200
// Microsoft SDK ̂̂Ƃ̂Ŕr
#define __IHTMLControlElement_INTERFACE_DEFINED__
#endif

#include <atlbase.h>
static CComModule _Module;
#include <atlwin.h>
#include <atlcom.h>
#include <atliface.h>
#define _ATL_DLL
#include <atlhost.h>
#include <ExDispID.h>

/**
 * VNiCxgfBXpb`jNX
 * NSHIFT{NbNł̕ʃEBhEI[vׂɁA
 * DISPID_NEWWINDOWtbNB
 */ 

class ATL_NO_VTABLE VNBSink :
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatch
{
public:
	CComPtr<IWebBrowser2> m_pBrowser;
	CWindow *showWhenComplete;
	bool disableControl;
	
	VNBSink() {
		m_pBrowser = NULL;
		showWhenComplete = NULL;
		disableControl = true;
	}

	BEGIN_COM_MAP(VNBSink)
		COM_INTERFACE_ENTRY(IDispatch)
		COM_INTERFACE_ENTRY_IID(DIID_DWebBrowserEvents2, IDispatch)
	END_COM_MAP()

// IDispatch
public:
	STDMETHOD (GetTypeInfoCount) (UINT* pctinfo)
	{
		return	E_NOTIMPL;
	}

	STDMETHOD (GetTypeInfo) (UINT itinfo, LCID lcid, ITypeInfo** pptinfo)
	{
		return	E_NOTIMPL;
	}

	STDMETHOD (GetIDsOfNames) (REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgdispid)
	{
		return	E_NOTIMPL;
	}

	STDMETHOD (Invoke) (DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult, EXCEPINFO* pexcepinfo, UINT* puArgErr)
	{
		HRESULT hr = S_OK;
		if ( pdispparams ) {
			switch ( dispidMember ) {
			case DISPID_DOCUMENTCOMPLETE:
				if (m_pBrowser) {
					CComPtr<IDispatch> pDisp;
					m_pBrowser->get_Document(&pDisp);
					if (pDisp) {
						CComQIPtr<IHTMLDocument2> pDoc = pDisp;
						if (pDoc) {
							USES_CONVERSION;
							CComBSTR str;
							pDoc->get_title(&str);
							showWhenComplete->SetWindowText(OLE2T(str));
						}
					}
				}
				if (showWhenComplete) {
					showWhenComplete->ShowWindow(TRUE);
				}
				break;
			case DISPID_NEWWINDOW:
			case DISPID_NEWWINDOW2:
			case DISPID_FRAMENEWWINDOW:
				// ݂̃EBhEł̂܂܃I[v
				//if ( m_pBrowser ) {
				//	VARIANT defArg;
				//	defArg.vt = VT_ERROR;
				//	defArg.scode = DISP_E_PARAMNOTFOUND;
				//	m_pBrowser->Navigate(pdispparams->rgvarg[5].bstrVal, &defArg, &defArg, pdispparams->rgvarg[2].pvarVal, &defArg);
				//}
				if (disableControl) {
					*(pdispparams->rgvarg[0].pboolVal) = VARIANT_TRUE;
				}
				break;
			default:
				break;
			}
		} else {
			hr = DISP_E_PARAMNOTFOUND;
		}
		return hr;
	}
};


/**
 * DHTML̊Oďo(window.external)ƊeUI󗝂邽߂̃NX
 * CAxWindow::SetExternalUIHandler Őݒ肷邱Ƃz肵ĂB
 * getExternal \bhŁAOĂяop IDispatch ԂĂB
 *
 * ݎĂ郁\bh
 * window.external.SetBackColor wiFݒ肷郁\bh
 *
 * ꂼNX̑Ή郁\bhĂяoĂBpĒgLq邱Ƃ
 * ύXłBp[^COMX^Ĉ(VARIANT)ɂȂ̂Œ
 */ 
class CHtmlExt : public IDocHostUIHandlerDispatch {

public:
	//----------------------------------------------------------------------------
	// IUnknown 
	
	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid,
											 void __RPC_FAR *__RPC_FAR *ppvObject) {
		if (riid == IID_IUnknown || riid == IID_IDispatch) {
			if (ppvObject == NULL)
				return E_POINTER;
			*ppvObject = this;
			AddRef();
			return S_OK;
		} else {
			*ppvObject = 0;
			return E_NOINTERFACE;
		}
	}

	ULONG STDMETHODCALLTYPE AddRef() {
		return 1;
	}

	ULONG STDMETHODCALLTYPE Release() {
		return 1;
	}

	//----------------------------------------------------------------------------
	// IDispatch 

	STDMETHOD(GetTypeInfoCount)(UINT* pctinfo) {
		return E_NOTIMPL;
	}

	STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo** pptinfo) {
		return E_NOTIMPL;
	}

	/**
	 * \bhID̑ΉƂ郁\bh
	 * regszNames Ƀ\bh̔z񂪂̂ŁA
	 * rgdispid ɑΉ dispid ԂĂ
	 */
	STDMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames,
							 LCID lcid, DISPID* rgdispid) {
		return E_NOTIMPL;
	}

	/**
	 * \bhs
	 * dispidMember Ń\bhw肳B pdispparams  VARIANT ̔z
	 * ̌`ł킽̂łg
	 */
	STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid,
					  LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult,
					  EXCEPINFO* pexcepinfo, UINT* puArgErr) {
		return E_NOTIMPL;
	}

	//----------------------------------------------------------------------------
	// IDocHostUIHandlerDispatch ̎

	/**
	 * ReLXgj[
	 * ȂƂŃj[Ă
	 */
	HRESULT STDMETHODCALLTYPE ShowContextMenu( 
		/* [in] */ DWORD dwID,
		/* [in] */ DWORD x,
		/* [in] */ DWORD y,
		/* [in] */ IUnknown __RPC_FAR *pcmdtReserved,
		/* [in] */ IDispatch __RPC_FAR *pdispReserved,
		/* [retval][out] */ HRESULT __RPC_FAR *dwRetVal) {
		*dwRetVal = S_OK;      //This is what the WebBrowser control is looking for.
		//You can show your own context menu here.
		return S_OK;        
	}

	HRESULT STDMETHODCALLTYPE GetHostInfo( 
		/* [out][in] */ DWORD __RPC_FAR *pdwFlags,
		/* [out][in] */ DWORD __RPC_FAR *pdwDoubleClick) {
		return E_NOTIMPL;
	}

	HRESULT STDMETHODCALLTYPE ShowUI( 
		/* [in] */ DWORD dwID,
		/* [in] */ IUnknown __RPC_FAR *pActiveObject,
		/* [in] */ IUnknown __RPC_FAR *pCommandTarget,
		/* [in] */ IUnknown __RPC_FAR *pFrame,
		/* [in] */ IUnknown __RPC_FAR *pDoc,
		/* [retval][out] */ HRESULT __RPC_FAR *dwRetVal) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE HideUI( void) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE UpdateUI( void) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE EnableModeless(
		/* [in] */ VARIANT_BOOL fEnable) {
		return E_NOTIMPL;
	}

	HRESULT STDMETHODCALLTYPE OnDocWindowActivate( 
		/* [in] */ VARIANT_BOOL fActivate) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE OnFrameWindowActivate(
		/* [in] */ VARIANT_BOOL fActivate) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE ResizeBorder( 
		/* [in] */ long left,
		/* [in] */ long top,
		/* [in] */ long right,
		/* [in] */ long bottom,
		/* [in] */ IUnknown __RPC_FAR *pUIWindow,
		/* [in] */ VARIANT_BOOL fFrameWindow) {
		return E_NOTIMPL;
	}
	
	HRESULT STDMETHODCALLTYPE TranslateAccelerator( 
		/* [in] */ DWORD hWnd,
		/* [in] */ DWORD nMessage,
		/* [in] */ DWORD wParam,
		/* [in] */ DWORD lParam,
		/* [in] */ BSTR bstrGuidCmdGroup,
		/* [in] */ DWORD nCmdID,
		/* [retval][out] */ HRESULT __RPC_FAR *dwRetVal) {
		return E_NOTIMPL;
	}
	
	HRESULT STDMETHODCALLTYPE GetOptionKeyPath( 
		/* [out] */ BSTR __RPC_FAR *pbstrKey,
		/* [in] */ DWORD dw) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE GetDropTarget( 
		/* [in] */ IUnknown __RPC_FAR *pDropTarget,
		/* [out] */ IUnknown __RPC_FAR *__RPC_FAR *ppDropTarget) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE GetExternal( 
		/* [out] */ IDispatch __RPC_FAR *__RPC_FAR *ppDispatch) {
		*ppDispatch = this;
		return S_OK;
	}
        
	HRESULT STDMETHODCALLTYPE TranslateUrl( 
		/* [in] */ DWORD dwTranslate,
		/* [in] */ BSTR bstrURLIn,
		/* [out] */ BSTR __RPC_FAR *pbstrURLOut) {
		return E_NOTIMPL;
	}
        
	HRESULT STDMETHODCALLTYPE FilterDataObject( 
		/* [in] */ IUnknown __RPC_FAR *pDO,
		/* [out] */ IUnknown __RPC_FAR *__RPC_FAR *ppDORet) {
		return E_NOTIMPL;
	}
};

class CBrowserWindow : public CWindowImpl<CBrowserWindow, CAxWindow>, public CHtmlExt
{
protected:
	bool disableControl; // 䐧ptO

public:
	LRESULT OnKeydown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled){

		// browser is a data member of type IWebBrowser2.
		// Using CComQIPtr in this way queries browser
		// for the IOleInPlaceActiveObject interface which is
		// then stored in the pIOIPAO variable.
		//
		CComQIPtr<IOleInPlaceActiveObject,
		&IID_IOleInPlaceActiveObject> pIOIPAO(browser);
		
		HRESULT hr = S_FALSE;

		// ꕔ̋@\EׂɃANZ[^Ă΂Ȃ悤ɂ
		switch ( wParam ) {
		case 'A': // SI
		case 'C': // Rs[
		case 'X': // Jbg
		case 'V': // y[Xg
		case 'Z': // UNDO
		case VK_TAB:    // ^u(̍)
		case VK_INSERT: // e킱҂؏?
		case VK_DELETE: // I폜
			if (pIOIPAO) {
				MSG msg;
				msg.message = uMsg;
				msg.wParam = wParam;
				msg.lParam = lParam;
				hr = pIOIPAO->TranslateAccelerator(&msg);
			}
			break;
		//case 'N':		// VKEBhE
		//case 'P':		// 
		//case 'O':		// I[v
		//case 'F':		// 
		default:
			break;
		}
		return hr;
	}

private:
	// uEŨRg[
	DWORD dwCookie;
	CComPtr<IUnknown> pSink;
public:
	CComPtr<IWebBrowser2> browser;

public:

	/**
	 * 
	 */
	CBrowserWindow(HWND hwnd, bool disableControl = true) : browser(0) {

		HRESULT hr;
		this->disableControl = disableControl;
		
		// eTCY擾
		RECT rect;
		if (hwnd) {
			::GetClientRect(hwnd, &rect);
		}
		
		// HTML Rg[쐬
		if (Create(hwnd, hwnd ? rect : rcDefault, NULL, hwnd ? WS_CHILD|WS_CLIPCHILDREN : WS_OVERLAPPEDWINDOW|WS_CLIPCHILDREN)) {
			hr = CreateControl(OLESTR("Shell.Explorer.2"));
			if (SUCCEEDED(hr)) {
				// g external pɓo^B
				// SetExternalDispatch {̖̂ړĨ\bh
				// IDocHostUIHandlerDispatch gꍇ͂ GetExternal D悳
				// ̂ŖӖɂȂBSetExternalUIHandler ł̈ꊇwsB
				if (disableControl) {
					hr = SetExternalUIHandler(static_cast<CHtmlExt*>(this));
				} else {
					hr = SetExternalDispatch(static_cast<CHtmlExt*>(this));
				}
				if (SUCCEEDED(hr)) {
					
					// C^[tF[X擾
					hr = QueryControl(&browser);
					
					// VNIuWFNg̍쐬
					CComObject<VNBSink>* sink;
					CComObject<VNBSink>::CreateInstance(&sink);
					
					// CxgDispatch̎w
					hr = sink->QueryInterface(IID_IUnknown, (void**)&pSink);
					if ( SUCCEEDED(hr) ) {
						hr = AtlAdvise(browser, pSink, DIID_DWebBrowserEvents2, &dwCookie);
						if ( SUCCEEDED(hr) ) {
							sink->m_pBrowser = browser;
							sink->showWhenComplete = this;
							sink->disableControl = disableControl;
						}
					}
				}
			}
			// XXX IE ɑ΂tbN{hook = gemEnvDepWinAddDispatchHook(BrowserDispatchHook, this);
		}
	}

	void end() {
		if (browser) {
			if ( pSink ) {
				AtlUnadvise(browser, DIID_DWebBrowserEvents2, dwCookie);
			}
			browser.Release();
			browser.Detach();
		}
	}

	/**
	 * 폜
	 */
	virtual ~CBrowserWindow() {
		close();
		if (m_hWnd) DestroyWindow();
		end();
	}
	
	bool isOk() {
		return m_hWnd && browser;
	}
	
	/**
	 * uEUN
	 * @param path NURL
	 */
	void open(const tjs_char *path) {

		{
			ttstr msg = "open:";
			msg += path;
			TVPAddLog(msg);
		}

		if (browser) {
			if (_wcsnicmp(TJS_W("http://"), path, 7) == 0) {
				CComVariant vUrl(path);
				CComVariant vempty;
				browser->Navigate2(&vUrl, &vempty, &vempty, &vempty, &vempty);
			} else {
				ttstr filename(path);
				::TVPGetLocalName(filename);
				TVPAddLog(filename);
				CComVariant vUrl(filename.c_str());
				CComVariant vempty;
				browser->Navigate2(&vUrl, &vempty, &vempty, &vempty, &vempty);
			}
		} else {
			if (m_hWnd) {
				ShowWindow(TRUE);
			}
		}
	}

	/**
	 * I
	 */
	virtual void close() {
		if (m_hWnd) {
			ShowWindow(FALSE);
		}
	}

	virtual void reload() {
		if (browser) browser->Refresh();
	}
	
	void back() {
		if (browser) browser->GoBack();
	}
	
	void forward() {
		if (browser) browser->GoForward();
	}
	
	/**
	 * ꏊw
	 */	
	void setPos(int x, int y, int w, int h) {
		RECT rect = {x, y, x+w, y+h};
		SetWindowPos(0, &rect, 0);
	}

	BEGIN_MSG_MAP(CBrowserWindow)
		MESSAGE_HANDLER(WM_KEYDOWN, OnKeydown)
	END_MSG_MAP()
};

/**
 * bZ[W̃tbNB̂o^łȂƂ܂Ȃc
 * TranslateMessage ADispatchMessage OɌĂяo
 * IE ɑ͂̃bZ[W肵ďłꏊɑ
 */
extern "C" int BrowserDispatchHook(MSG *msg, void *vwork)
{
	CBrowserWindow *br = (CBrowserWindow*)vwork;
	if (IsChild(br->m_hWnd, msg->hwnd)) {
		if ((msg->message >= WM_KEYFIRST && msg->message <= WM_KEYLAST)) {
			// L[͂IE̐eɂȂĂ CBrowserWindow ɑ
			SendMessage(br->m_hWnd, msg->message, msg->wParam, msg->lParam);
			//  IE ɂĂ
//		} else if (msg->message == WM_COMMAND) {
//			// WM_COMMAND ͂ɐeɑ
//			SendMessage(br->parentHwnd, msg->message, msg->wParam, msg->lParam);
//			// ɑKvȂ̂Ŏ̂Ă
//			return 1;
		}
	}
	return 0;
}

//---------------------------------------------------------------------------

#include "IDispatchWrapper.hpp"

/**
 * p TJS pɎ
 * windows.external  global Ƀ}bsOĂ܂
 */
class TJSBrowserWindow : public CBrowserWindow {

protected:
	IDispatchWrapper *global;
	
public:
	/// RXgN^
	TJSBrowserWindow(HWND hwnd, bool disableControl = true) : CBrowserWindow(hwnd, disableControl) {
		global = new IDispatchWrapper(TVPGetScriptDispatch());
	}

	/// fXgN^
	~TJSBrowserWindow() {
		global->Release();
	}
	
	/**
	 * \bhID̑ΉƂ郁\bh
	 * regszNames Ƀ\bh̔z񂪂̂ŁA
	 * rgdispid ɑΉ dispid ԂĂ
	 */
	STDMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgdispid) {
		return global->GetIDsOfNames(riid, rgszNames, cNames, lcid, rgdispid);
	}
	
	/**
	 * \bhs
	 * dispidMember Ń\bhw肳B pdispparams  VARIANT ̔z
	 * ̌`ł킽̂łg
	 */
	STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid,
					  LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult,
					  EXCEPINFO* pexcepinfo, UINT* puArgErr) {
		return global->Invoke(dispidMember, riid, lcid, wFlags, pdispparams, pvarResult, pexcepinfo, puArgErr);
	}
};


//---------------------------------------------------------------------------

/*
	vOCŃlCeBuꂽNX񋟂AggŎgpł悤
	łB

	lCeBuNX tTJSNativeInstance pNXɍ쐬ÃlC
	eBuNXƂ̃C^[tF[X tTJSNativeClassForPlugin x[Xɍ쐬
	܂B

	uTJS2 t@Xv́ugݍ݂̎v́u{IȎgvɂƓ
	NXł͍쐬܂BAvOCŎsATJS2 t@
	XɂƂ͎኱̎dقȂ邱ƂɒӂĂB
*/

//---------------------------------------------------------------------------
// eXgNX
//---------------------------------------------------------------------------
/*
	eIuWFNg (iTJSDispatch2 C^[tF[X) ɂ̓lCeBuCX^X
	Ă΂AiTJSNativeInstance ^̃IuWFNgo^邱ƂłA
	IuWFNgoƂł܂B
	܂AlCeBuCX^X̎łBlCeBuCX^Xɂ
	tTJSNativeInstance NX𓱏o܂BtTJSNativeInstance 
	iTJSNativeInstance ̊{IȓĂ܂B
*/
class NI_Browser : public tTJSNativeInstance // lCeBuCX^X
{

public:
	TJSBrowserWindow *win;

	NI_Browser()
	{
		// RXgN^
		/*
			NI_Browser ̃RXgN^łBC++ NXƂĂ̏ q
			Construct ōς܂ĂAConstruct ł͍̏ŏ̕
			ɂ邱Ƃ߂܂B̗ł́Af[^o Value ɏ
			lƂ 0 ݒ肵Ă܂B
		 */
		win = NULL;
	}

	tjs_error TJS_INTF_METHOD
		Construct(tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *tjs_obj)
	{
		// TJS2 IuWFNg쐬ƂɌĂ΂
		/*
			TJS2  new Zq TJS2 IuWFNg쐬ƂɌĂ΂܂B
			numparams  param  new Zqɓnꂽ\Ă܂B
			tjs_obj ́A쐬 TJS IuWFNgłB
			̗ł́A (ɂꂪ void Ŗ)A Value
			̏lƂĐݒ肵Ă܂B
		*/
		HWND handle = 0;
		if (numparams >= 1 && param[0]->Type() == tvtInteger) {
			handle = (HWND)(int)*param[0];
		}
		win = new TJSBrowserWindow(handle);
		return S_OK;
	}

	void TJS_INTF_METHOD Invalidate()
	{
		// IuWFNgƂɌĂ΂
		if (win) {
			delete win;
		}
	}
};
//---------------------------------------------------------------------------
/*
	 NI_Browser ̃IuWFNg쐬ĕԂ̊֐łB
	q TJSCreateNativeClassForPlugin ̈Ƃēn܂B
*/
static iTJSNativeInstance * TJS_INTF_METHOD Create_NI_Browser()
{
	return new NI_Browser();
}
//---------------------------------------------------------------------------
/*
	TJS2 ̃lCeBuNX͈ӂ ID ŋʂĂKv܂B
	͌q TJS_BEGIN_NATIVE_MEMBERS }NŎIɎ擾܂A
	 ID i[ϐƁA̕ϐŐ錾܂B
	lɂ͖ ID \ -1 w肵ĂB
*/
#define TJS_NATIVE_CLASSID_NAME ClassID_Browser
static tjs_int32 TJS_NATIVE_CLASSID_NAME = -1;
//---------------------------------------------------------------------------
/*
	TJS2 ṕuNXv쐬ĕԂ֐łB
*/
static iTJSDispatch2 * Create_NC_Browser()
{
	/*
		܂ANX̃x[XƂȂNXIuWFNg쐬܂B
		ɂ TJSCreateNativeClassForPlugin p܂B
		TJSCreateNativeClassForPlugin ̑P̓NXAQ
		lCeBuCX^XԂ֐w肵܂B
		쐬IuWFNgꎞIɊi[郍[Jϐ̖O
		classobj łKv܂B
	*/
	tTJSNativeClassForPlugin * classobj =
		TJSCreateNativeClassForPlugin(TJS_W("Browser"), Create_NI_Browser);


	/*
		TJS_BEGIN_NATIVE_MEMBERS }NłBɂ TJS2 ŎgpNX
		w肵܂B
		̃}N TJS_END_NATIVE_MEMBERS }Nŋ܂ꂽꏊɁANX
		oƂȂׂ\bhvpeB̋Lq܂B
	*/
	TJS_BEGIN_NATIVE_MEMBERS(/*TJS class name*/Browser)

		/*
			 finalize \bh錾܂Bfinalize ɑ鏈
			tTJSNativeInstance::Invalidate I[o[Ch邱Ƃłł
			܂̂ŁAʏ͋̃\bhŏ\łB
		*/
		TJS_DECL_EMPTY_FINALIZE_METHOD

		/*
			(TJS) RXgN^錾܂BTJS ŃNXƂA
			NXŃNXƓ̃\bh錾Ă镔ɑ܂B

			TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL }N̂PԖڂ̈̓lCeBu
			CX^XɊ蓖ĂϐŁAQʖڂ̈͂̕ϐ̌^łB
			̗ł̂̃ubNł NI_Browser * _this Ƃϐp\ŁA
			lCeBuCX^XɃANZX邱Ƃł܂B
			}N̂RԖڂ̈́ATJS ŎgpNXw肵܂B
			TJS_END_NATIVE_CONSTRUCTOR_DECL }N̈lłB
			ARXgN^ɑ鏈 tTJSNativeInstance::Construct
			I[o[Ch鎖Ŏł̂ŁAł͉ S_OK 
			܂B
		*/
		TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL(
			/*var.name*/_this,
			/*var.type*/NI_Browser,
			/*TJS class name*/Browser)
		{
			// NI_Browser::Construct ɂeLqł̂
			// ł͉Ȃ
			return TJS_S_OK;
		}
		TJS_END_NATIVE_CONSTRUCTOR_DECL(/*TJS class name*/Browser)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/open) // open \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_Browser);
			if (numparams < 1) return TJS_E_BADPARAMCOUNT;
			_this->win->open(param[0]->GetString());
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/open)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/setPos) // setPos \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_Browser);
			if (numparams < 4) return TJS_E_BADPARAMCOUNT;
			_this->win->setPos(*param[0], *param[1], *param[2], *param[3]);
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/setPos)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/close) // setPos \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_Browser);
			_this->win->close();
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/close)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/back) // back \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_Browser);
			_this->win->back();
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/back)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/forward) // back \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_Browser);
			_this->win->forward();
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/forward)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/reload) // back \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_Browser);
			_this->win->reload();
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/reload)


	TJS_END_NATIVE_MEMBERS

	/*
		̊֐ classobj Ԃ܂B
	*/
	return classobj;
}
//---------------------------------------------------------------------------
/*
	TJS_NATIVE_CLASSID_NAME ͈ꉞ undef Ăق悢ł傤
*/
#undef TJS_NATIVE_CLASSID_NAME
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason,
	void* lpReserved)
{
	return 1;
}
//---------------------------------------------------------------------------
static tjs_int GlobalRefCountAtInit = 0;
extern "C" HRESULT _stdcall _export V2Link(iTVPFunctionExporter *exporter)
{
	// X^ȕ(KLq)
	TVPInitImportStub(exporter);

	tTJSVariant val;

	// TJS ̃O[oIuWFNg擾
	iTJSDispatch2 * global = TVPGetScriptDispatch();

	{
		//-----------------------------------------------------------------------
		// 1 ܂NXIuWFNg쐬
		iTJSDispatch2 * tjsclass = Create_NC_Browser();
		
		// 2 tjsclass  tTJSVariant ^ɕϊ
		val = tTJSVariant(tjsclass);
		
		// 3 ł val  tjsclass ێĂ̂ŁAtjsclass 
		//   Release 
		tjsclass->Release();
		
		
		// 4 global  PropSet \bhpAIuWFNgo^
		global->PropSet(
			TJS_MEMBERENSURE, // oȂꍇɂ͍쐬悤ɂtO
			TJS_W("Browser"), // o ( Ȃ炸 TJS_W( ) ň͂ )
			NULL, // qg ( {̓õnbVlANULL ł悢 )
			&val, // o^l
			global // ReLXg ( global ł悢 )
			);
		//-----------------------------------------------------------------------
	}

	// - global  Release 
	global->Release();

	// Ao^֐ꍇ 1 ` 4 JԂ

	// val NAB
	// ͕KsBȂ val ێĂIuWFNg
	//  Release ꂸAɎg TVPPluginGlobalRefCount mɂȂȂB
	val.Clear();

	// ̎_ł TVPPluginGlobalRefCount ̒l
	GlobalRefCountAtInit = TVPPluginGlobalRefCount;
	// ƂčTĂBTVPPluginGlobalRefCount ͂̃vOC
	// ǗĂ tTJSDispatch hIuWFNg̎QƃJE^̑vŁA
	// ɂ͂ƓAȂȂĂȂƂȂȂB
	// ȂĂȂ΁Aǂʂ̂ƂŊ֐ȂǂQƂĂāA
	// vOC͉łȂƌƂɂȂB

	// ATL֘A
	_Module.Init(NULL, NULL);
	AtlAxWinInit();
	
	return S_OK;
}
//---------------------------------------------------------------------------
extern "C" HRESULT _stdcall _export V2Unlink()
{
	// ggAvOC悤ƂƂɌĂ΂֐B

	// 炩̏ŃvOCłȂꍇ
	// ̎_ E_FAIL Ԃ悤ɂB
	// ł́ATVPPluginGlobalRefCount  GlobalRefCountAtInit 
	// 傫ȂĂΎsƂƂɂB
	if(TVPPluginGlobalRefCount > GlobalRefCountAtInit) return E_FAIL;
		// E_FAIL AƁAPlugins.unlink \bh͋UԂ

	/*
		ANX̏ꍇAɁuIuWFNggpłvƂƂ
		m邷ׂ܂B{Iɂ́APlugins.unlink ɂvOC̉
		댯łƍlĂ ( Plugins.link ŃNAŌ
		ŃvOCAvOIƓɎIɉ̂g)B
	*/

	// TJS ̃O[oIuWFNgɓo^ Browser NXȂǂ폜

	// - ܂ATJS ̃O[oIuWFNg擾
	iTJSDispatch2 * global = TVPGetScriptDispatch();

	// - global  DeleteMember \bhpAIuWFNg폜
	if(global)
	{
		// TJS ̂ɉĂƂȂǂ
		// global  NULL ɂȂ蓾̂ global  NULL łȂ
		// Ƃ`FbN

		global->DeleteMember(
			0, // tO ( 0 ł悢 )
			TJS_W("Browser"), // o
			NULL, // qg
			global // ReLXg
			);
	}
	
	// - global  Release 
	if(global) global->Release();

	// X^u̎gpI(KLq)
	TVPUninitImportStub();

	_Module.Term();
	
	return S_OK;
}
//---------------------------------------------------------------------------

